#!/usr/bin/perl -w
use strict;

my $login;
my $pass;
my $pass_again;

my $file_miss = 0;

use CGI;
use FindBin;

BEGIN {
if ( -f $FindBin::Bin.'/env.pl' ) {
    require $FindBin::Bin.'/env.pl';
}
else {
    $file_miss = 1;
}
}

use Digest::MD5;

main_menu();

############################################################################
sub main_menu
############################################################################
{
    print <<HEADER;
Content-Type: text/html

<html>
<head><title>Create new account</title></head>
<body>
HEADER

    if ($file_miss) {
        print <<HTML;
        Can not find env.pl .
HTML
        exit;
    }

    if (!test_pass_file()) {
        print <<HTML;
        Account already exist. Please, login in usual way.
HTML
        exit;
    }

    if (!get_params()) {
        print_form();
    } else {
        write_pass_file();
    }

    print <<FOOTER;
</body>
</html>
FOOTER


}   ##main_menu

############################################################################
sub get_params
############################################################################
{
    my $q = new CGI;
    $login = $q->param("login");
    $pass = $q->param("pass");
    $pass_again = $q->param("pass_again");

    if ( !$login or !$pass or !$pass_again) {
        return 0;
    }
    if ( $pass ne $pass_again) {
        print "Passwords must be equal.<p>";
        return 0;
    }

    return 1;
}   ##get_params

############################################################################
sub print_form
############################################################################
{
	print <<HTML;
	<table align=center>
    <form method=POST action=new_account.pl>
	<tr>
     <td colspan=2 align=center><h3> Enter disired Login and Password for authentication by AL Download Protection. </h3> </td>
	</tr>

	<tr>
     <td> Login</td>
	 <td>
       <input type=text name=login size=20 value='$login'>
	 </td>
	</tr>
	<tr>
     <td>Password</td>
	 <td>
       <input type=password name=pass size=20>
	 </td>
    </tr>
	<tr>
     <td>Password again</td>
	 <td>
       <input type=password name=pass_again size=20>
	 </td>
	</tr>

	<tr>
	 <td>
	   <p><p><input type=submit name=action value='Continue'>
	 </td>
	 <td> </td>
	</tr>

	</form>
	</table>
HTML

}   ##print_form


############################################################################
sub test_pass_file
############################################################################
{
    if (!open F, "< $env::infile") {
         #print "Can't open passwd: $!<p>\n";
         return 1;
    }

    seek (F , 0, 2);
    if ( tell(F) <= 0 ) {
        close (F);
        return 1;
    }

    close (F);
    return 0;
}   ##test_pass_file

############################################################################
sub write_pass_file
############################################################################
{
    my $md5_passwd=Digest::MD5::md5_hex($pass);
    my $out = "$login\t$md5_passwd\n";

    if (!open F, "> $env::infile") {
         print "Can't open passwd: $env::infile: $!<p>\n";
         return 0;
    }
    binmode (F);
    print F $out;
    truncate(F,tell(F));
    close(F);

    if ( $env::System_type eq "unix" ) {
        chmod $env::File_mode, $env::infile;
    }

    print "New account was created successfully.";
    return 1;
}   ##write_pass_file



