#!/usr/bin/perl -w
package add_tag;

# find common environment - begin
BEGIN {
use FindBin;
push (@INC, $FindBin::Bin);
require "env.pl";
};
# find common environment - end

use strict;
use POSIX qw(strftime);
use POSIX qw(locale_h);
use XML::DOM;

if ( $0 =~ /add_tag/ ) {
    #called separately; work as filter
    &execute(\*STDIN, \*STDOUT);
} else {
    # otherwise require-d from other script;
    # wait for call of &execute
    1; #make require happy
}

############################################################################
sub execute
############################################################################
{
  eval {
        my ($STDIN, $STDOUT) = @_;

        my $parser = new XML::DOM::Parser;
        my $doc = $parser->parse(*$STDIN);

        my $lifetagS = $doc->getElementsByTagName ("lifetime");
        #my $exptagS = $doc->getElementsByTagName("expire");

        if ($lifetagS->getLength())
        {
	 my $lifetag = $lifetagS->item(0);
	 my $per_str = $lifetag -> getAttribute("period");
         my $parent = $lifetag->getParentNode();
         my $exptagS = $parent->getElementsByTagName("expire");

	 my $i = substr ($per_str,0,length($per_str)-1);
	 my $m = substr ($per_str,-1,1);

	 my $seconds;

	 if ($m eq "h")    { $seconds = $i*60*60;      }       # hours
	 elsif ($m eq "m") { $seconds = $i*60 ;        }       # minutes
	 else              { $seconds = $i*24*60*60;   }       # days

	 if ($env::System_type eq 'unix') {
         	setlocale ( LC_TIME,"en_US.ISO8859-1"); #unix
	 } else {
         	setlocale ( LC_TIME,"English");
	 }

	 my $time_string = strftime ("%a, %d %b %Y %H:%M:%S GMT",gmtime(time()+$seconds));

	 my $newnode = $doc->createElement("expire");
	 $newnode -> setAttribute ("date",$time_string);
         #my $parent = $lifetag->getParentNode();

	 if ( $exptagS->getLength() )
	 {
	  my $exptag = $exptagS->item(0);
	  $parent->replaceChild ($newnode, $exptag);
	 }
	 else
	 {
	   $parent->appendChild($newnode);
	 }

	}

        # Print doc file

        print $STDOUT $doc->toString;

        # Avoid memory leaks - cleanup circular references for garbage collection
        $doc->dispose();

  };
  return $@ ? 112 : 0;

}   ##execute
