package crypt;

use strict;
use Fcntl ':flock';
use File::Basename;
use File::Copy;
use sdep;

require "env.pl";
require "Package_DB.pm";

if ( $env::System_type eq 'win' ) {
     require File::Temp;
     require "add_tag.pl";
     require "comm_socks.pl";
}

return "ok";

##########################################################################
# Recrypt all packages
# Params: link and Referer.
##########################################################################
sub recrypt_all_packages
{
#    open (FD, "+> $env::recrypt_lock") or return "";
#    die "Cann't open $env::recrypt_lock";
#    flock (FD, LOCK_EX);
    #non block

    my $dir_path = $env::Package_base.$env::Path_Delim;
    my $mask = $dir_path."*".$env::extension;
    my @packages = <${mask}>;
    my $pack;
    my $current_time = time();
    my $pub_packages = $env::Public_base.$env::Path_Delim."packages";

    foreach (@packages) {
        my $file = $_;
        $pack = substr ($_, length($dir_path),
            length($_)-length($dir_path)-length($env::extension));
        my $dfile = $pub_packages.$env::Path_Delim.$pack.$env::extension_crypt;
        my $dtmp  = $pub_packages.$env::Path_Delim.$pack.'.rcv';

	if (need_recrypt($pack, $current_time)) {

        if ( $env::System_type eq 'win' ) {
            # pipe & redirections works bad
            # doing work in two steps

            local *MYSTDIN;
            local *MYSTDOUT;
            my $result = 0;

            my ($htempfile, $tname) = File::Temp::tempfile();
            binmode $htempfile;

            open (MYSTDIN, "< $file");
            binmode MYSTDIN;
            $result = add_tag::execute(\*MYSTDIN, $htempfile);
            close(MYSTDIN);

            if ( $result ) {
                close($htempfile);
                eval { unlink ($tname); };
                next;
            }

            seek($htempfile, 0, 0);

            open (MYSTDOUT, "> ".$dtmp);
            binmode MYSTDOUT;
            $result = comm_socks::execute($htempfile, \*MYSTDOUT);
            close (MYSTDOUT);

            close($htempfile);
            eval { unlink ($tname); };

            if ( !$result ) {
               File::Copy::move($dtmp, $dfile);
               Package_DB::set_crypt_info($pack, "", time());
            } else {
                eval { unlink $dtmp; };
            }

        } else {
            # unix
            my $cmd = "${env::bin}/add_tag.pl <$file | ${env::bin}/comm_socks.pl >$dtmp";
            if (system($cmd) == 0) {
               File::Copy::move($dtmp, $dfile);
               Package_DB::set_crypt_info($pack, "", time());
            } else {
                eval { unlink $dtmp; };
            }
        }
	}

    }

#    close (FD);
    return "";
}


sub need_recrypt
{
	my $pack = $_[0] || "";
	my $current_time = $_[1] || time();
	my ($period, $last_crypt_time) = Package_DB::get_crypt_info($pack);
	my $last;

	$last_crypt_time = $last_crypt_time || 0;
	$period = $period || "3h";

	$last = chop($period);
	if ($last eq "m" || $last eq "M") {
		$period *= 60;
	}
	if ($last eq "h" || $last eq "H") {
		$period *= 60*60;
	}
	if ($last eq "d" || $last eq "D") {
		$period *= 60*60*24;
	}

	if (($last_crypt_time+$period) <= $current_time) {
		return "recrypt";
	}
	return "";
}

