#!/usr/bin/perl -w
use POSIX;
use sdep;

require "env.pl";
#return "Ok";

# param time()
sub formate_date
{
  my $tm=$_[0];
#  my $res= $tm->ymd;
  my $res= strftime('%Y-%m-%d' , gmtime($tm));

  return $res;
}

# param time()
sub formate_date_full
{
  my $tm=$_[0];
  my $res= strftime('%Y-%m-%d %H:%M:%S' , gmtime($tm));

  return $res;
}

# param time()
sub getdate_2m_ago
{
    my $now=$_[0];
    my @result;
    $result[0]=$now-58*24*60*60;
    $result[1]=58;

    my $current_day = strftime('%d' , gmtime($now));
    my $day = strftime('%d' , gmtime($result[0]));

#    while(($result[1]<=62) && ($now->mday != $result[0]->mday))
    while(($result[1]<=62) && ($day != $current_day))
    {
         $result[0] = $result[0] - 24*60*60;
         $day = strftime('%d' , gmtime($result[0]));
         $result[1]++;
    }
return $result[0];
}

sub getbuffer{
        my $much=$_[0];
        my $i=0;
	my $j;
	my $k;
	my @buffer;
	open FILE, "<$env::statfile" or die "Can't open stats: $!\n";
	binmode(FILE);
        flock(FILE,1);
	while(<FILE>) {
	     $i++;
        }
	if($i >= (50+$much))
	{
	      $j=$i-(50+$much);
	      $i=$i-$much;
	}
	else
	{
	      $j=0;
	      if(($i > $much) && ($i <= (50+$much)))
	      {
	         $i=$i-$much;
	      }
	      else
	      {
	         $i=0;
	      }
	}

	seek(FILE,0,0) or die "Seek failed! $!";
        $.=0;
	while(<FILE>){
	   $k=$i-$.;
	   if(($.>=$j) && ($.<=$i)){
               $buffer[$k]=$_;
	   }
	}
	close FILE;
	return @buffer;

}

sub get_package
{
 my @result;
 my $i=0;
 my $filename;

 opendir(DIRHANDLE,$env::Package_base) or die "can't open dir:$!\n";
 while (defined($filename=readdir(DIRHANDLE)))
 {
   if(($filename ne ".")&&($filename ne "..")){
	$result[$i]=$filename;
	$i++;
   }
 }
 closedir(DIRHANDLE);
return @result;
}

sub is_in_the_list
{
   my($elem,@list)=@_;
   my $item;
   my $i=0;
   if(!defined($elem))
   {
     return "Empty";
   }
   foreach $item(@list){
	      last if($item eq $elem);
	      $i++;
   }
  if($i == (scalar(@list)))
  {
              return "Unknown";
  }
  else
  {
              return $i;
  }

}
sub collect_day_stats
{
    my @buf;
    my @total;
    my @complete;
    my @sum;
    my @res;
    my @p_list=get_package();
    my $unknown;

    my $item;
    my  ($date,$host,$package_name,$f_name,$status,$start,$end,$attempts,$b_size);

    open(F, "< $env::statfile")     or die "can't read $env::statfile : $!";
    binmode(FILE);
    flock(F,1);
    my $stat = <F>;
    if(defined($stat))
    {
       ($date,$host,$package_name,$f_name,$status,$start,$end,$attempts,$b_size)=split(/\t/,$stat);
       $unknown = is_in_the_list($package_name,@p_list);
       if($unknown eq "Unknown")
       {
           $buf[0]="Unknown\t$f_name";
       }
       else
       {
        $buf[0]="$package_name\t$f_name";
       }
       $total[0]=1;
       if($status eq "Completed")
       {
	       $complete[0]=1;
       }
       else
       {
	       $complete[0]=0;

       }
       $sum[0]=$b_size;
       my $i=0;
    }
    my $i=0;
    while(<F>)
    {
        ($date,$host,$package_name,$f_name,$status,$start,$end,$attempts,$b_size)=split(/\t/,$_);
         $unknown = is_in_the_list($package_name,@p_list);
         if($unknown eq "Unknown")
         {
            $stat="Unknown\t$f_name";
         }
         else
         {
            $stat="$package_name\t$f_name";
         }

         foreach $item(@buf){
	    last if($item eq $stat);
	    $i++;
        }
	if($i == (scalar(@buf)))
	{

	   $buf[$i] = $stat;
	   $total[$i]=1;
	   if($status eq "Completed")
	   {
	       $complete[$i]=1;
	   }
           else
           {
	       $complete[$i]=0;
           }
	   $sum[$i]=$b_size;
	}
	else
	{
	   $total[$i]++;
	   if($status eq "Completed")
	   {
	       $complete[$i]++;
	   }
	   $sum[$i]=$sum[$i]+$b_size;

	}
        $i=0;
   }
   $i=0;
#   print "ready to return\n";
   while ($i<scalar(@buf))
   {
      my ($ldate, $hour) = split(/ /, $date);
      $res[$i]="$ldate\t$buf[$i]\t$total[$i]\t$complete[$i]\t$sum[$i]";
#      print "\t$res[$i]\n";
      $i++;
   }
#   print "end ready to return\n";

   close (F) or die "Couldn't close $env::statfile : $!";

   return @res;
}

sub write_day_stats
{
   my @buf=collect_day_stats();
   my $i=0;

   open(FILE, "+>> $env::statlog")     or die "can't read $env::statlog : $!";
   binmode(FILE);
   flock(FILE,2);
   while($i<scalar(@buf))
   {
      print FILE "$buf[$i]\n";
     $i++;
   }
   close (FILE) or die "Couldn't close $env::statlog : $!";

   return @buf;
}

sub get_day_stats
{
   my $day_ness=$_[0];
   my $flag=0;
   my ($date,$package_name,$f_name,$total,$complete,$size);
   my $stat;
   my @res;

   open FILE, "<$env::statlog" or die "Can't open statlog: $!\n";
   binmode(FILE);
   flock(FILE,1);
   $stat=<FILE>;
   if ( $stat ) {
     ($date,$package_name,$f_name,$total,$complete,$size)=split(/\t/,$stat);
   }
   if(!defined $date || $day_ness le $date)
   {
      $res[0]=-1;
   }
   else
   {
      if($date eq $day_ness)
      {
          chomp;
      push(@res,$stat);
	  $flag++;
      }
      while(<FILE>)
      {
	   if(/^$day_ness\t/)
	   {
              chomp;
	      push(@res,$_);
	      $flag++;
	   }
      }
   }
   close FILE;
#    if($flag==0)
#    {
#      push(@res,"-1");
#    }
   return @res;
}

