#!/usr/bin/perl -w
use strict;

use CGI;
use POSIX;

# find common environment - begin
BEGIN {
if ($ENV{SERVER_SOFTWARE} =~ /Microsoft-IIS/) {
my ($myPath, @myDir, $last, $catalog);
$myPath = $ENV{"PATH_TRANSLATED"};
if ($myPath ne "") {
   $myPath =~ s/\\/\//g;
   @myDir = split ("/", $myPath);
   $last = pop (@myDir);
   $catalog = join ('/', @myDir);
   $catalog =~ s/\//\\/g;
   push (@INC, $catalog);
};
};
require "env.pl";
};
# find common environment - end

use IO::Dir;
use XML::DOM;

require "auth_chk.pm";
require "trigger.pm";

require "my_subs.pm";
require "main_menu.pm";

my  $auth_cookie=check_auth();
if($auth_cookie)
{

my $query = new CGI;
my $fileName = $query->param("fileName");

my $fullName = $fileName.$env::extension;
my $fileExist = 0;

my $node;
my $parent;
my $empty;

print <<HTML;

<HTML>
<HEAD>
<title>Edit new package</title>
<LINK REL="stylesheet" TYPE="text/css" HREF="$env::Css_file_path">
</HEAD>
<BODY>

HTML

main_menu ("new", "./");

if (length ($fileName) != 0) {
   my $d = new IO::Dir $env::Package_base;


   if (defined $d) {
      while (defined($_ = $d->read)) {
         if ($fullName eq $_) {
            $fileExist = 1;
         }
      };

      if ($fileExist) {

print <<HTML;

<br><div align="center">
<table border=0 cellspacing=4 cellpadding=1><tr><td class='border'>
<table border=0 cellspacing=0 cellpadding=0>
<tr><td colspan=2 align='center' class='hd'><img border=0 src=$env::LineGif_file_path height=1 width=15>
File <b>$fileName</b> already exist
<img border=0 src=$env::LineGif_file_path height=1 width=15></td></tr>
<tr><td colspan=2 align='center' class='hd'>
<b>REWRITE ?</b>
</td></tr>
<tr><td colspan=2 align='center' class='hd'>
<img border=0 src=$env::LineGif_file_path height=15 width=15></td></tr>
<tr><td align = 'center' class='hd'>
<form method="POST" action="edit_package.pl">
<input type="hidden" value=$fileName name="fileName">
<input type="submit" value="yes" name="submit">
</form>
</td><td align = 'center' class='hd'>
<form method="POST" action="new.pl">
<input type="submit" value="no" name="submit">
<input type="hidden" value=$fileName name="fileName">
</form>
</td></tr>
</table>
</td></tr></table>
</div>

HTML

      }
      else {

         my $parser = new XML::DOM::Parser;
         my $template = $parser->parsefile ($env::template_xml);
         my $path = $env::Package_base.$env::Path_Delim.$fullName;

         my $new = new FileHandle ($path, "w");

         if (defined $new) {
            $parent = $template->getElementsByTagName ("package")->item(0);
            $node = $template->getElementsByTagName ("protection")->item(0);
            $empty = $node->getNextSibling;
            $parent->removeChild ($node);
            $parent->removeChild ($empty);

            # OK, protection deleted. Now recreate it manually to guess the first referrer
            my $before = $parent->getElementsByTagName ("stat")->[0];
            if ( $before ) {
                my $before = $parent->getElementsByTagName ("content")->[0];
            }
            $node = $template->createElement("protection");
            $parent->insertBefore($node, $before);
            $empty = $template->createTextNode("\n");
            $parent->insertBefore($empty, $before);
            my $child = $template->createElement("referer");
            $child->setAttribute("href",$env::Server_Root);
            $node->appendChild($child);
            $empty = $template->createTextNode("\n  ");
            $node->appendChild($empty);
            $empty = $template->createTextNode("\n   ");
            $node->insertBefore($empty, $child);

            #$node = $template->getElementsByTagName ("stat")->item(0);
            #$empty = $node->getNextSibling;
            #$parent->removeChild ($node);
            #$parent->removeChild ($empty);
            #
            # Suggest stat href:
            $node = $template->getElementsByTagName ("stat")->item(0);
            $empty = $node->getNextSibling;
            if ( $node ) {
                my $node2 = $node->getElementsByTagName ("report")->item(0);
                my $empty2 = $node2->getNextSibling;
                if ( $node2 ) {
                     $node2->setAttribute("href", $env::Server_Root.'/stats/stats.pl');
                }
                $node->removeChild ($empty2);
            }
            $parent->removeChild ($empty);

            $parent = $template->getElementsByTagName ("content")->item(0);
            $node = $template->getElementsByTagName ("base")->item(0);
            $empty = $node->getNextSibling;
            $parent->removeChild ($node);
            $parent->removeChild ($empty);

            $node = $template->getElementsByTagName ("file")->item(0);
            $empty = $node->getNextSibling;
            $parent->removeChild ($node);
            $parent->removeChild ($empty);

         $template->print ($new);


#      $template->dispose;
            $new->close;
            my_subs::edit_dom ($fileName);
         }
      };
      $d->rewind;
   }
   else {

print <<HTML;
<div align="center">
<table border=0 cellspacing=4 cellpadding=1><tr><td class='border'>
<table border=0 cellspacing=0 cellpadding=0>
<tr><td colspan=2 align=center><div class="hd">
You have not permission for this directory<br>
</td></tr></table></td></tr></table></div>
HTML

   }
}
else {

print <<HTML;
<div align="center">
<table border=0 cellspacing=4 cellpadding=1><tr><td class='border'>
<table border=0 cellspacing=0 cellpadding=0>
<tr><td colspan=2 align=center><div class="hd">
There no file name<br>
</td></tr></table></td></tr></table></div>
HTML

}

main_menu ("new", "./");

print <<HTML;

</BODY>
</HTML>

HTML

} # auth_cookie
